#include "framework/opengl.h"
#include "framework/shader.h"

//Already defined in Menu.h
//#define GK(x) if(keys[x])
//#define GKT(x) if(!keys[x] && keytemp[x])

char fontstr[50],shader1[50],shader2[50];

texture_t ftex; 
CTimer timer;
int fps;
Camera cam;
double timespan=0;

float fpsq;

glShader shader;


// All Setup For OpenGL Goes Here

int InitGL(GLvoid)
{

        FILE *config;
        config=fopen("data/settings.txt","rt");

        fscanf(config,"\n[FILES]\n\n");
        fscanf(config,"FONT: %s\n",&fontstr);
        fscanf(config,"LOGO: %s\n",&shader1);
        fscanf(config,"VERTEX_SHADER: %s\n",&shader1);
        fscanf(config,"FRAGMENT_SHADER: %s\n",&shader2);
        fclose(config);
        MultiTexturing();
        initGLShader(true);
        
        shader=LoadGLShader(shader1,shader2);
        
        timer.Init();
        fps=0;

        
        glClearColor(0,0,0,1);
        ftex=LoadTexture(fontstr,false);
        glBuildFont(ftex);
        glEnable(GL_TEXTURE_2D);
        glShadeModel(GL_SMOOTH);
		glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
		//glEnable(GL_POLYGON_SMOOTH);
		cam.init(0,0,0,0,0,100);
        
        
        return TRUE;
                                                                   // Initialization Went OK
}
//**********************************************************
//getKeys for Input handling
//**********************************************************

void getKeys(){
     for(int x=0;x<256;x++) if(keys[x]) keytemp[x]=true;
     

}//getKeys


//**********************************************************
//Main drawing Routine
//**********************************************************

int DrawGLScene(GLvoid)                                                // Here's Where We Do All The Drawing
{
fps=(int)timer.GetFPS();
fpsq=(float)40/(float)fps;

        GK(VK_F1){//Helpscreen
                glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);        // Clear The Screen And The Depth Buffer
                glLoadIdentity();
                glPrint(255,0,0, 300,60,"3D-Caste Controls",(int)cam.yrot);
                /*glPrint(192,192,192,270,100,"Uparrow   -   Forward");
                glPrint(192,192,192,270,140,"Downarrow -   Break/Back");
                glPrint(192,192,192,270,180,"Leftarrow -   Steer/look left");
                glPrint(192,192,192,270,220,"Rightarrow-   Steer/look right");
                glPrint(192,192,192,270,260,"Space     -   Stop");
                glPrint(192,192,192,270,300,"End       -   Reset");
                glPrint(255,255,255,270,380,"ESC       -   Quit");*/
        }
        else{
        
        getKeys();
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);        // Clear The Screen And The Depth Buffer
        glLoadIdentity();
        cam.update(fpsq);
        cam.positionCamera();
        glUnbindAll();
        glColor3f(1.0,0.5,0.8);
        glBindShader(shader);
        glBindTex(ftex,0);
        glPassTexToShader(shader,"texUnit0");
        glBegin(GL_QUADS);
                          glColor3f(1.0,0.5,0.8);glTexVert(0,0,-2,-2,0);
                          glColor3f(1.0,0.5,0.8);glTexVert(1,0,2,-2,0);
                          glColor3f(1.0,0.5,0.8);glTexVert(1,1,2,2,0);
                          glColor3f(1.0,0.5,0.8);glTexVert(0,1,-2,2,0);
        glEnd();
        glUnbindShader();
        
        glLoadIdentity();
        //********************************************************
        //drawing done, so print text to screen
        
        glBindTex(ftex);

        glPrint(255,0,0, 20,20,"FPS: %i",fps);
        //glPrint(255,0,0, 20,40,"x: %f  y: %f  z: %f",cam.pos.x, cam.pos.y,cam.pos.z);
        //glPrint(255,0,0, 20,60,"yrot: %i",(int)cam.yrot);
        //glPrint(0,0,0,0,0,"");
    
           
        }//else GK(VK_F1)

        return TRUE;                                                            // Keep Going
}
